# SmallMapWindow Class Reference

Class managing the smallmap window. More...

Inheritance diagram for SmallMapWindow:

## Public Member Functions
| SmallMapWindow (const WindowDesc *desc, int window_number)
uint | GetMaxLegendHeight () const
| Compute maximal required height of the legends.
uint | GetMinLegendWidth () const
| Compute minimal required width of the legends.
uint | GetNumberColumnsLegend (uint width) const
| Return number of columns that can be displayed in width pixels.
uint | GetLegendHeight (uint width) const
| Compute height given a width.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
void | SmallMapCenterOnCurrentPos ()
## Private Types
enum | SmallMapType { SMT_CONTOUR, SMT_VEHICLES, SMT_INDUSTRY, SMT_ROUTES, SMT_VEGETATION, SMT_OWNER }
| Types of legends in the SM_WIDGET_LEGEND widget. More...
## Private Member Functions
int | RemapX (int tile_x) const
| Remap a map's tile X coordinate (TileX(TileIndex)) to a location on this smallmap.
int | RemapY (int tile_y) const
| Remap a map's tile Y coordinate (TileY(TileIndex)) to a location on this smallmap.
void | DrawSmallMapStuff (void *dst, uint xc, uint yc, int pitch, int reps, uint32 mask, Blitter *blitter, GetSmallMapPixels *proc) const
| Draws one column of the small map in a certain mode onto the screen buffer.
void | DrawVehicles (const DrawPixelInfo *dpi, Blitter *blitter) const
| Adds vehicles to the smallmap.
void | DrawTowns (const DrawPixelInfo *dpi) const
| Adds town names to the smallmap.
void | DrawMapIndicators () const
| Adds map indicators to the smallmap.
void | DrawSmallMap (DrawPixelInfo *dpi) const
| Draws the small map.
## Static Private Member Functions
static void | DrawVertMapIndicator (int x, int y, int y2)
| Draws vertical part of map indicator.
static void | DrawHorizMapIndicator (int x, int x2, int y)
| Draws horizontal part of map indicator.
## Private Attributes
uint | min_number_of_columns
| Minimal number of columns in legends.
uint | min_number_of_fixed_rows
| Minimal number of rows in the legends for the fixed layouts only (all except SMT_INDUSTRY).
uint | column_width
| Width of a column in the SM_WIDGET_LEGEND widget.
int32 | scroll_x
int32 | scroll_y
int32 | subscroll
uint8 | refresh
| refresh counter, zeroed every FORCE_REFRESH_PERIOD ticks
## Static Private Attributes
static SmallMapType | map_type = SMT_CONTOUR
| Currently displayed legends.
static bool | show_towns = true
| Display town names in the smallmap.
static const uint | LEGEND_BLOB_WIDTH = 8
| Width of the coloured blob in front of a line text in the SM_WIDGET_LEGEND widget.
static const uint | INDUSTRY_MIN_NUMBER_OF_COLUMNS = 2
| Minimal number of columns in the SM_WIDGET_LEGEND widget for the SMT_INDUSTRY legend.
static const uint8 | FORCE_REFRESH_PERIOD = 0x1F
| map is redrawn after that many ticks

## Detailed Description

Class managing the smallmap window.

Definition at line 445 of file smallmap_gui.cpp.

## Member Enumeration Documentation

enum SmallMapWindow::SmallMapType`[private]`

Types of legends in the SM_WIDGET_LEGEND widget.

Definition at line 447 of file smallmap_gui.cpp.

## Member Function Documentation

int SmallMapWindow::RemapX | ( | int | tile_x | ) | const`[inline, private]`

Remap a map's tile X coordinate (TileX(TileIndex)) to a location on this smallmap.

Parameters:

  | tile_x | the tile's X coordinate.

Returns:
  the X coordinate to draw on.

Definition at line 478 of file smallmap_gui.cpp.

References TILE_SIZE.

Referenced by DrawTowns(), and DrawVehicles().

int SmallMapWindow::RemapY | ( | int | tile_y | ) | const`[inline, private]`

Remap a map's tile Y coordinate (TileY(TileIndex)) to a location on this smallmap.

Parameters:

  | tile_y | the tile's Y coordinate.

Returns:
  the Y coordinate to draw on.

Definition at line 489 of file smallmap_gui.cpp.

References TILE_SIZE.

void SmallMapWindow::DrawSmallMapStuff | ( | void * | dst,
|  | uint | xc,
|  | uint | yc,
|  | int | pitch,
|  | int | reps,
|  | uint32 | mask,
|  | Blitter * | blitter,
|  | GetSmallMapPixels * | proc |
| ) |  |  | const`[inline, private]`

Draws one column of the small map in a certain mode onto the screen buffer.

This function looks exactly the same for all types

Parameters:

  | dst | Pointer to a part of the screen buffer to write to.
  | xc | The X coordinate of the first tile in the column.
  | yc | The Y coordinate of the first tile in the column
  | pitch | Number of pixels to advance in the screen buffer each time a pixel is written.
  | reps | Number of lines to draw
  | mask | Some bytes may need to be masked out when at the border of drawn area
  | blitter | current blitter
  | proc | Pointer to the colour function

See also:
  GetSmallMapPixels(TileIndex)

Definition at line 508 of file smallmap_gui.cpp.

References _settings_game, GameSettings::construction, DrawPixelInfo::dst_ptr, ConstructionSettings::freeform_edges, DrawPixelInfo::height, IsInsideMM(), MapMaxX(), MapMaxY(), Blitter::MoveTo(), Blitter::SetPixelIfEmpty(), and TileXY().

Referenced by DrawSmallMap().

void SmallMapWindow::DrawVehicles | ( | const DrawPixelInfo * | dpi,
|  | Blitter * | blitter |
| ) |  |  | const`[inline, private]`

Adds vehicles to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into
  | blitter | current blitter

Definition at line 547 of file smallmap_gui.cpp.

References DrawPixelInfo::dst_ptr, DrawPixelInfo::height, IsInsideMM(), DrawPixelInfo::left, map_type, RemapX(), Blitter::SetPixel(), TILE_SIZE, DrawPixelInfo::top, VEH_EFFECT, DrawPixelInfo::width, Point::x, and Point::y.

Referenced by DrawSmallMap().

void SmallMapWindow::DrawTowns | ( | const DrawPixelInfo * | dpi | ) | const`[inline, private]`

Adds town names to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into

Definition at line 596 of file smallmap_gui.cpp.

References DrawString(), FONT_HEIGHT_SMALL, DrawPixelInfo::height, Window::left, DrawPixelInfo::left, RemapX(), SetDParam(), TileX(), TileY(), Window::top, DrawPixelInfo::top, DrawPixelInfo::width, Point::x, and Point::y.

Referenced by DrawSmallMap().

static void SmallMapWindow::DrawVertMapIndicator | ( | int | x,
|  | int | y,
|  | int | y2 |
| ) |  |  | `[inline, static, private]`

Draws vertical part of map indicator.

Parameters:

  | x | X coord of left/right border of main viewport
  | y | Y coord of top border of main viewport
  | y2 | Y coord of bottom border of main viewport

Definition at line 626 of file smallmap_gui.cpp.

References GfxFillRect().

Referenced by DrawMapIndicators().

static void SmallMapWindow::DrawHorizMapIndicator | ( | int | x,
|  | int | x2,
|  | int | y |
| ) |  |  | `[inline, static, private]`

Draws horizontal part of map indicator.

Parameters:

  | x | X coord of left border of main viewport
  | x2 | X coord of right border of main viewport
  | y | Y coord of top/bottom border of main viewport

Definition at line 638 of file smallmap_gui.cpp.

References GfxFillRect().

Referenced by DrawMapIndicators().

void SmallMapWindow::DrawSmallMap | ( | DrawPixelInfo * | dpi | ) | const`[inline, private]`

Draws the small map.

Basically, the small map is draw column of pixels by column of pixels. The pixels are drawn directly into the screen buffer. The final map is drawn in multiple passes. The passes are:

1. The colours of tiles in the different modes.
2. Town names (optional)

Parameters:

  | dpi | pointer to pixel to write onto

Definition at line 682 of file smallmap_gui.cpp.

References _colour_gradient, DrawMapIndicators(), DrawSmallMapStuff(), DrawTowns(), DrawVehicles(), DrawPixelInfo::dst_ptr, BlitterFactoryBase::GetCurrentBlitter(), GfxFillRect(), DrawPixelInfo::height, DrawPixelInfo::left, map_type, Blitter::MoveTo(), OWNER_END, OWNER_NONE, OWNER_TOWN, OWNER_WATER, DrawPixelInfo::pitch, show_towns, TILE_SIZE, DrawPixelInfo::top, and DrawPixelInfo::width.

Referenced by DrawWidget().

uint SmallMapWindow::GetMaxLegendHeight | ( |  | ) | const`[inline]`

Compute maximal required height of the legends.

Returns:
  Maximally needed height for displaying the smallmap legends in pixels.

Definition at line 803 of file smallmap_gui.cpp.

References _smallmap_industry_count, FONT_HEIGHT_SMALL, max(), min_number_of_columns, min_number_of_fixed_rows, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetMinLegendWidth | ( |  | ) | const`[inline]`

Compute minimal required width of the legends.

Returns:
  Minimally needed width for displaying the smallmap legends in pixels.

Definition at line 812 of file smallmap_gui.cpp.

References column_width, min_number_of_columns, and WD_FRAMERECT_LEFT.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetNumberColumnsLegend | ( | uint | width | ) | const`[inline]`

Return number of columns that can be displayed in width pixels.

Returns:
  Number of columns to display.

Definition at line 820 of file smallmap_gui.cpp.

References column_width.

Referenced by DrawWidget(), GetLegendHeight(), and OnClick().

uint SmallMapWindow::GetLegendHeight | ( | uint | width | ) | const`[inline]`

Compute height given a width.

Returns:
  Needed height for displaying the smallmap legends in pixels.

Definition at line 828 of file smallmap_gui.cpp.

References _smallmap_industry_count, FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), max(), min_number_of_fixed_rows, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

virtual void SmallMapWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 835 of file smallmap_gui.cpp.

References map_type, SetDParam(), and SM_WIDGET_CAPTION.

virtual void SmallMapWindow::OnInit | ( |  | ) | `[inline, virtual]`

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note:
  nested_root and/or nested_array (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 844 of file smallmap_gui.cpp.

References column_width, LegendAndColour::end, GetStringBoundingBox(), Window::height, INDUSTRY_MIN_NUMBER_OF_COLUMNS, LEGEND_BLOB_WIDTH, lengthof, max(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::MAX_SIZE, min_number_of_columns, min_number_of_fixed_rows, SetDParam(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and Window::width.

virtual void SmallMapWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 877 of file smallmap_gui.cpp.

References _dynlang, _industry_counts, _smallmap_industry_count, Rect::bottom, column_width, DrawSmallMap(), DrawString(), LegendAndColour::end, FillDrawPixelInfo(), FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), GfxFillRect(), Rect::left, LEGEND_BLOB_WIDTH, map_type, max(), min_number_of_fixed_rows, NUM_INDUSTRYTYPES, Rect::right, SetDParam(), SM_WIDGET_LEGEND, SM_WIDGET_MAP, TD_RTL, DynamicLanguages::text_dir, Rect::top, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void SmallMapWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 937 of file smallmap_gui.cpp.

References Window::DrawWidgets().

virtual void SmallMapWindow::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 942 of file smallmap_gui.cpp.

References _dynlang, _left_button_clicked, _smallmap_industry_count, _smallmap_industry_show_heightmap, column_width, NWidgetBase::current_x, ViewportData::dest_scrollpos_x, ViewportData::dest_scrollpos_y, FindWindowById(), ViewportData::follow_vehicle, FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), Window::HandleButtonClick(), INVALID_VEHICLE, Window::left, Window::LowerWidget(), map_type, max(), min_number_of_fixed_rows, CursorVars::pos, NWidgetBase::pos_x, NWidgetBase::pos_y, Window::RaiseWidget(), Window::SetDirty(), Window::SetWidgetLoweredState(), LegendAndColour::show_on_map, show_towns, SM_WIDGET_CENTERMAP, SM_WIDGET_CONTOUR, SM_WIDGET_DISABLEINDUSTRIES, SM_WIDGET_ENABLEINDUSTRIES, SM_WIDGET_INDUSTRIES, SM_WIDGET_LEGEND, SM_WIDGET_MAP, SM_WIDGET_OWNERS, SM_WIDGET_ROUTES, SM_WIDGET_SELECTINDUSTRIES, SM_WIDGET_SHOW_HEIGHT, SM_WIDGET_TOGGLETOWNNAME, SM_WIDGET_VEGETATION, SM_WIDGET_VEHICLES, TD_RTL, DynamicLanguages::text_dir, Window::top, Window::viewport, ViewPort::virtual_height, ViewPort::virtual_width, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, Point::x, and Point::y.

virtual void SmallMapWindow::OnRightClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the right mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 1052 of file smallmap_gui.cpp.

References SM_WIDGET_MAP.

virtual void SmallMapWindow::OnScroll | ( | Point | delta | ) | `[inline, virtual]`

Handle the request for (viewport) scrolling.

Parameters:

  | delta | the amount the viewport must be scrolled.

Reimplemented from Window.

Definition at line 1069 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, CursorVars::fix_at, MapMaxX(), MapMaxY(), Window::SetDirty(), SM_WIDGET_MAP, TILE_SIZE, Point::x, and Point::y.

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp